package org.hexworks.zircon.api.animation

/**
 * Represents the states an [Animation] can be in.
 */
enum class AnimationState {

    /**
     * The `Animation` is in progress and will finish
     * at some point in the future.
     */
    IN_PROGRESS,
    /**
     * The [Animation] is infinite, it will not
     * finish on its own.
     */
    INFINITE,
    /**
     * The [Animation] is finished.
     */
    FINISHED
}
