package org.hexworks.zircon.api

import org.hexworks.zircon.api.builder.component.ColorThemeBuilder
import org.hexworks.zircon.api.resource.ColorThemeResource

object ColorThemes {

    @JvmStatic
    fun newBuilder() = ColorThemeBuilder()

    /**
     * Taken from
     * http://www.colourlovers.com/palette/580974/Adrift_in_Dreams
     */
    @JvmStatic
    fun adriftInDreams() = ColorThemeResource.ADRIFT_IN_DREAMS


    /**
     * Taken from
     * http://www.colourlovers.com/palette/49963/let_them_eat_cake
     */
    @JvmStatic
    fun letThemEatCake() = ColorThemeResource.LET_THEM_EAT_CAKE

    /**
     * Taken from
     * http://www.colourlovers.com/palette/559428/lucky_bubble_gum
     */
    @JvmStatic
    fun luckyBubbleGum() = ColorThemeResource.LUCKY_BUBBLE_GUM

    @JvmStatic
    fun techLight() = ColorThemeResource.TECH_LIGHT

    /**
     * Taken from
     * http://www.colourlovers.com/palette/953498/Headache
     */
    @JvmStatic
    fun headache() = ColorThemeResource.HEADACHE

    /**
     * Taken from
     * http://www.colourlovers.com/palette/148712/Gamebookers
     */
    @JvmStatic
    fun gamebookers() = ColorThemeResource.GAMEBOOKERS

    /**
     * Taken from
     * http://www.colourlovers.com/palette/903157/Entrapped_InAPalette
     */
    @JvmStatic
    fun entrappedInAPalette() = ColorThemeResource.ENTRAPPED_IN_A_PALETTE

    /**
     * Taken from
     * http://www.colourlovers.com/palette/678929/War
     */
    @JvmStatic
    fun war() = ColorThemeResource.WAR

    /**
     * Taken from
     * http://www.colourlovers.com/palette/557832/Captured_By_Pirates
     */
    @JvmStatic
    fun capturedByPirates() = ColorThemeResource.CAPTURED_BY_PIRATES

    /**
     * Taken from
     * http://www.colourlovers.com/palette/4454375/ghost_of_a_chance
     */
    @JvmStatic
    fun ghostOfAChance() = ColorThemeResource.GHOST_OF_A_CHANCE

    /**
     * Taken from
     * http://www.colourlovers.com/palette/1585870/after_the_heist
     */
    @JvmStatic
    fun afterTheHeist() = ColorThemeResource.AFTER_THE_HEIST

    /**
     * Taken from
     * http://www.colourlovers.com/palette/731302/pablo_neruda
     */
    @JvmStatic
    fun pabloNeruda() = ColorThemeResource.PABLO_NERUDA

    /**
     * Taken from
     * http://www.colourlovers.com/palette/27905/threadless
     */
    @JvmStatic
    fun threadless() = ColorThemeResource.THREADLESS

    /**
     * Taken from
     * http://www.colourlovers.com/palette/38562/Hands_On
     */
    @JvmStatic
    fun handsOn() = ColorThemeResource.HANDS_ON

    /**
     * Taken from
     * http://www.colourlovers.com/palette/2031222/Olive_Leaf_Tea
     */
    @JvmStatic
    fun oliveLeafTea() = ColorThemeResource.OLIVE_LEAF_TEA

    /**
     * All Solarized themes are taken from:
     * http://www.zovirl.com/2011/07/22/solarized_cheat_sheet/
     */
    @JvmStatic
    fun solarizedDarkYellow() = ColorThemeResource.SOLARIZED_DARK_YELLOW

    @JvmStatic
    fun solarizedDarkOrange() = ColorThemeResource.SOLARIZED_DARK_ORANGE

    @JvmStatic
    fun solarizedDarkRed() = ColorThemeResource.SOLARIZED_DARK_RED

    @JvmStatic
    fun solarizedDarkMagenta() = ColorThemeResource.SOLARIZED_DARK_MAGENTA

    @JvmStatic
    fun solarizedDarkViolet() = ColorThemeResource.SOLARIZED_DARK_VIOLET

    @JvmStatic
    fun solarizedDarkBlue() = ColorThemeResource.SOLARIZED_DARK_BLUE

    @JvmStatic
    fun solarizedDarkCyan() = ColorThemeResource.SOLARIZED_DARK_CYAN

    @JvmStatic
    fun solarizedDarkGreen() = ColorThemeResource.SOLARIZED_DARK_GREEN

    @JvmStatic
    fun solarizedLightYellow() = ColorThemeResource.SOLARIZED_LIGHT_YELLOW

    @JvmStatic
    fun solarizedLightOrange() = ColorThemeResource.SOLARIZED_LIGHT_ORANGE

    @JvmStatic
    fun solarizedLightRed() = ColorThemeResource.SOLARIZED_LIGHT_RED

    @JvmStatic
    fun solarizedLightMagenta() = ColorThemeResource.SOLARIZED_LIGHT_MAGENTA

    @JvmStatic
    fun solarizedLightViolet() = ColorThemeResource.SOLARIZED_LIGHT_VIOLET

    @JvmStatic
    fun solarizedLightBlue() = ColorThemeResource.SOLARIZED_LIGHT_BLUE

    @JvmStatic
    fun solarizedLightCyan() = ColorThemeResource.SOLARIZED_LIGHT_CYAN

    @JvmStatic
    fun solarizedLightGreen() = ColorThemeResource.SOLARIZED_LIGHT_GREEN

}
